Skip to content

RFC 9855 - TI-LFA

Field Value
Title Topology Independent Fast Reroute Using Segment Routing
Authors A. Bashandy, S. Litkowski, C. Filsfils, P. Francois, B. Decraene, D. Voyer
Date October 2025
Status Proposed Standard
Working group RTGWG (draft-ietf-rtgwg-segment-routing-ti-lfa)
Link datatracker.ietf.org/doc/rfc9855

Summary

RFC 9855 defines Topology Independent Loop-Free Alternate (TI-LFA), the fast-reroute mechanism for node and adjacency segments in Segment Routing networks. It builds on LFA (RFC 5286), Remote LFA (RFC 7490) and Directed LFA, and extends them to provide guaranteed coverage in any two-connected network running a link-state IGP — hence "topology independent". It protects against the failure of a single link, a single node or a single SRLG.

The defining choice is to repair onto the expected post-convergence path: the path the PLR will use once the IGP has converged without the failed resource. Because the repair path matches the final path, traffic does not move twice, and operators do not need to tune tie-breaks between many possible backups. The PLR encodes the repair path as a short repair list (RL) of node and adjacency segments; for SRv6, the list is added with an RFC 8986 headend behavior.

Key Sections

Section Topic Description
2.1 Terminology P-space, extended P-space, Q-space, SPT_old/SPT_new, explicit path EP(P,Q)
3 Base Principle Pre-compute the post-convergence SPT and encode it as a loop-free segment list
4 P-space and Q-space over post-convergence paths Computing the extended P-space and Q-space along the post-convergence path, and scaling the Q-space computation
5 TI-LFA Repair Path Direct neighbor (5.1), PQ node (5.2), adjacent P and Q (5.3), distant P and Q (5.4)
6 Repair lists for SR segments What to do when the active segment is a node segment or an adjacency segment
7 Data-plane considerations MPLS label handling (7.1) and SRv6 (7.2)
8 TI-LFA and SR Algorithms Protecting Flex-Algo SIDs with the algorithm's own constraints
9 Adjacency segments in the repair list Using unprotected Adj-SIDs to avoid double FRR
App. A Post-convergence path Why repairing onto it is better
App. B Real topologies Repair-list size distribution on nine networks

P-Space, Q-Space, and PQ Node

Concept Definition
P-space P(R,X) Routers reachable from R on pre-convergence shortest paths without any of those paths (including ECMP splits) crossing the protected resource X
Extended P-space The union of the P-spaces of R's neighbors, excluding neighbors reached via X
Q-space Q(D,X) Routers from which the destination is reached without any path (including ECMP splits) crossing X
PQ node A node in both the (extended) P-space and the Q-space; the term comes from RFC 7490
P node / Q node Nodes in only one of the two spaces; a repair through them needs an explicit path between them

Repair List Construction

Section Scenario Repair list Comparable to
5.1 A direct neighbor on the post-convergence path is in P and Q Empty (new outgoing interface only) Post-convergence LFA
5.2 A PQ node exists <Node-SID(PQ)> Remote LFA
5.3 P and Q nodes are adjacent <Node-SID(P), Adj-SID(P→Q)> Directed LFA
5.4 P and Q nodes are distant <Node-SID(P), explicit path to Q> —

When the packet's active segment is a node segment, it stays on the packet and the RL is added in front of it (§6.1). When it is an adjacency segment, the PLR repairs toward the far end of that adjacency (§6.2).

For SRv6 (§7.2) the computation is unchanged. Adjacency SIDs are globally routable, so the list is often shorter than on SR-MPLS. A transit PLR adds the RL with an RFC 8986 §5 headend behavior; a PLR that is also a segment endpoint for the packet first executes its endpoint behavior.

Protection Types

Protection Level What is Protected Computation
Link Protection Single link failure Post-convergence SPF excluding the protected link
Node Protection Failure of the neighbor on the primary link Post-convergence SPF excluding that neighbor and all its links
SRLG Protection Links sharing fate with the primary link Post-convergence SPF excluding the configured set of links sharing a risk group with it

TI-LFA vs Other FRR Mechanisms

Mechanism Published coverage Requires SR Repairs onto post-convergence path Topology dependent
LFA (RFC 5286) 67–99% per prefix on 11 SP cores (RFC 6571) No Not necessarily Yes
Remote LFA (RFC 7490) 97.5–100% link protection on 14 topologies (RFC 7490) No (LDP tunnel) Not necessarily Yes
TI-LFA Any two-connected network; >99% with ≤ 1 SID for link protection (App. B) Yes Yes No

Microloops

TI-LFA is local to the PLR and does not prevent microloops elsewhere during convergence. The RFC notes that if the PLR converges early and stops using its TI-LFA path, especially one built per §5.2–5.4, microloops can appear. It recommends combining TI-LFA with microloop-avoidance techniques such as the local convergence delay of RFC 8333.

Common Pitfalls

  • TI-LFA requires Segment Routing to be enabled. Without SR, the repair segment list cannot be constructed.
  • Repair lists are limited by the PLR's maximum SID depth; some platforms skip a backup that needs more SIDs than they can impose.
  • Node protection is strictly stronger than link protection but may produce longer repair segment lists, and the node-protecting path is used even when only the link failed.
  • SRLG protection requires that SRLG membership be consistently configured across all nodes. Inconsistent SRLG definitions lead to inadequate protection.
  • The post-convergence path computation assumes all nodes reconverge to the same topology. Asymmetric link costs or misconfigured metrics can invalidate this assumption.
  • TI-LFA protects the data plane within 50ms, but the control plane still needs full IGP convergence. During the window between FRR activation and convergence, traffic follows the repair path, which may differ from the final converged path.

References

  1. RFC 9855 - Topology Independent Fast Reroute Using Segment Routing
  2. RFC 5286 - Basic Specification for IP Fast Reroute: Loop-Free Alternates
  3. RFC 7490 - Remote Loop-Free Alternate (LFA) Fast Reroute (FRR)
  4. RFC 8402 - Segment Routing Architecture
  5. RFC 6571 - LFA Applicability in Service Provider Networks (coverage measurements)
  6. RFC 8333 - Micro-loop Prevention by Introducing a Local Convergence Delay